Imports System
Imports System.ComponentModel

Imports DevExpress.Xpo
Imports DevExpress.Data.Filtering

Imports DevExpress.ExpressApp
Imports DevExpress.Persistent.Base
Imports DevExpress.Persistent.BaseImpl
Imports DevExpress.Persistent.Validation

Imports DevExpress.ExpressApp.ConditionalAppearance
<DefaultClassOptions()> _
<NavigationItem(False), CreatableItem(False)> _
Public Class WorkflowSystemSteps '-- Folyamatmenedzsment iktatáshoz
    Inherits BaseObject
    Private _WorkflowSystem As WorkflowSystem
    Private _ShortName As String
    Private _StepIndex As Long
    Private _TaskDescription As String
    Private _HRResponsibleGroups As HRGroups
    Private _HRResponsible As HRPerson
    Private _ExpirationDayofFailure As Long
    Private _HRDayofFailurePerson As HRPerson
    Private _ActionOnSuccess As eWFAction
    Private _ActionOnFailure As eWFAction
    Private _IsLastStep As Boolean = False
    Private _IsReadyForImport As Boolean = False 'Kész arra, hogy a könyvelés importálja
    Private _StepFinancialType As eStepFinancialType = eStepFinancialType.eNoCheck
    Private _AlertPeriod As AlertPeriod
    Public Sub New(ByVal session As Session)
        MyBase.New(session)
    End Sub
    Public Overrides Sub AfterConstruction()
        MyBase.AfterConstruction()
        'If Session.IsNewObject(Me) Then
        '    Dim _WorkflowSystemStep As WorkflowSystemSteps
        '    Dim I As Long = 1
        '    If Me.WorkflowSystem IsNot Nothing Then
        '        For Each _WorkflowSystemStep In Me.WorkflowSystem.WorkflowSystemSteps
        '            If I < _WorkflowSystemStep.StepIndex Then
        '                I = _WorkflowSystemStep.StepIndex
        '            End If
        '        Next
        '        StepIndex = I
        '    Else
        '        StepIndex = I
        '    End If

        'End If
    End Sub
    <Association("WFS-WFSSteps", GetType(WorkflowSystem))> _
    Property WorkflowSystem() As WorkflowSystem
        Get
            Return _WorkflowSystem
        End Get
        Set(ByVal value As WorkflowSystem)
            SetPropertyValue("WorkflowSystem", _WorkflowSystem, value)
        End Set
    End Property
    Property ShortName() As String
        Get
            Return _ShortName
        End Get
        Set(ByVal value As String)
            SetPropertyValue("ShortName", _ShortName, value)
        End Set
    End Property
    Property StepIndex As Long
        Get
            Return _StepIndex
        End Get
        Set(ByVal value As Long)
            SetPropertyValue("StepIndex", _StepIndex, value)
        End Set
    End Property
    Property TaskDescription As String
        Get
            Return _TaskDescription
        End Get
        Set(ByVal value As String)
            SetPropertyValue("TaskDescription", _TaskDescription, value)
        End Set
    End Property
    Property HRResponsibleGroups As HRGroups
        Get
            Return _HRResponsibleGroups
        End Get
        Set(ByVal value As HRGroups)
            SetPropertyValue("HRResponsibleGroups", _HRResponsibleGroups, value)
        End Set
    End Property
    Property HRResponsible As HRPerson
        Get
            Return _HRResponsible
        End Get
        Set(ByVal value As HRPerson)
            SetPropertyValue("HRResponsible", _HRResponsible, value)
        End Set
    End Property
    Property ExpirationDayofFailure As Long
        Get
            Return _ExpirationDayofFailure
        End Get
        Set(ByVal value As Long)
            SetPropertyValue("ExpirationDayofFailure", _ExpirationDayofFailure, value)
        End Set
    End Property
    Property HRDayofFailurePerson As HRPerson
        Get
            Return _HRDayofFailurePerson
        End Get
        Set(ByVal value As HRPerson)
            SetPropertyValue("HRDayofFailurePerson", _HRDayofFailurePerson, value)
        End Set
    End Property
    Property ActionOnSuccess As eWFAction
        Get
            Return _ActionOnSuccess
        End Get
        Set(ByVal value As eWFAction)
            SetPropertyValue("ActionOnSuccess", _ActionOnSuccess, value)
        End Set
    End Property
    Property ActionOnFailure As eWFAction
        Get
            Return _ActionOnFailure
        End Get
        Set(ByVal value As eWFAction)
            SetPropertyValue("ActionOnFailure", _ActionOnFailure, value)
        End Set
    End Property
    Property IsLastStep As Boolean
        Get
            Return _IsLastStep
        End Get
        Set(ByVal value As Boolean)
            SetPropertyValue("IsLastStep", _IsLastStep, value)
        End Set
    End Property
    Property IsReadyForImport As Boolean
        Get
            Return _IsReadyForImport
        End Get
        Set(ByVal value As Boolean)
            SetPropertyValue("IsReadyForImport", _IsReadyForImport, value)
        End Set
    End Property
    Property StepFinancialType As eStepFinancialType
        Get
            Return _StepFinancialType
        End Get
        Set(ByVal value As eStepFinancialType)
            SetPropertyValue("StepFinancialType", _StepFinancialType, value)
        End Set
    End Property
    Property AlertPeriod As AlertPeriod
        Get
            Return _AlertPeriod
        End Get
        Set(value As AlertPeriod)
            SetPropertyValue("AlertPeriod", _AlertPeriod, value)
        End Set
    End Property
End Class

